<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>blog.winny.tech</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">
<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<h1 class="title">Posts tagged "networking":</h1>
<div class="post-date">31 Aug 2020</div><h1 class="post-title"><a href="2020-08-12-when-nat-bites-—-use-a-reverse-vpn.html">When NAT Bites — Use a Reverse VPN</a></h1>
<nav id="table-of-contents">
<h2>Table of Contents</h2>
<div id="text-table-of-contents">
<ul>
<li><a href="#org10cdd91">How to ssh into a home server box &#x2014; the standard way</a>
<ul>
<li><a href="#orgae3d30c">Allowing ssh logins oven IPv6</a></li>
<li><a href="#org356e451">Allowing ssh logins over IPv4</a></li>
</ul>
</li>
<li><a href="#org1362730">What can go wrong?</a></li>
<li><a href="#org69f0fbd">A few options</a>
<ul>
<li><a href="#org91d635e">Punt the socket using socat</a></li>
<li><a href="#org1158eb6">Better: Using OpenSSH</a></li>
<li><a href="#org47c2aa6">My Solution: Use OpenVPN</a></li>
</ul>
</li>
<li><a href="#orgf61e06b">Steps to set up (based off my playbooks)</a>
<ul>
<li><a href="#orgabc7cda">Set up the certificate authority &amp; certificates</a></li>
<li><a href="#org2b654f1">Set up the OpenVPN Server (Internet-side)</a></li>
<li><a href="#org72b01c1">Set up the OpenVPN Client (Your Firewalled Host)</a></li>
<li><a href="#org6358f82">Set up another OpenVPN client on your PC</a></li>
</ul>
</li>
<li><a href="#orgb426dff">Wishlist</a>
<ul>
<li><a href="#orgb3b4552">VPN Host Discovery</a></li>
<li><a href="#org63d31e1">Domain Names for VPN Hosts</a></li>
<li><a href="#org5f7d008">Configure the VPN Clients' LAN segments be routable from other Clients</a></li>
</ul>
</li>
</ul>
</div>
</nav>
<p>
Sometimes I find myself setting up servers on networks with less than ideal
network configuration.  Most home internets use dynamic IP addresses, which
requires extra work to ensure I know the IP address to use when logging into
the network from the internet.  Another concern is how unreliable home
networking gear can be, especially with users tweaking settings without fully
appreciating what they're doing.  As a result, I've devised an alternate
solution to ensure I can always log into boxes hosted on home internet
connections.
</p>

<div id="outline-container-org10cdd91" class="outline-2">
<h2 id="org10cdd91">How to ssh into a home server box &#x2014; the standard way</h2>
<div class="outline-text-2" id="text-org10cdd91">
<p>
Let's say I am to set up a box on a home network.  I want to ensure I can log
in via SSH from the outside world &#x2014; that is anywhere online.  In IPv6 and
IPv4 land it is equally painful and possibly unreliable.
</p>
</div>

<div id="outline-container-orgae3d30c" class="outline-3">
<h3 id="orgae3d30c">Allowing ssh logins oven IPv6</h3>
<div class="outline-text-3" id="text-orgae3d30c">
<p>
After setting up the box on the network, I will need to configure the router's
<b>firewall</b> to allow SSH traffic on through.  In the case of IPv6 this is as
simple as telling the router to allow traffic inbound on port 22 to my box's
IPv6 address, which is globally routable and unique to my box.  One more thing:
the ISP gives each IPv6-enabled subscriber a IPv6 prefix, which is a bunch of
IPv6 addresses that the customer's equipment utilize via SLAAC.  Let's work
through an example:
</p>

<ol class="org-ol">
<li>The ISP gives your router IPv6 prefix <code>2001:db8:a:b::/64</code><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> via DHCPv6</li>
<li>Every device on the network assigns itself an IPv6 address via SLAAC</li>
<li>Each device on the network is globally routed via a unique IPv6 address.
For example the server box is <code>2001:db8:a:b::1</code>, the router is
<code>2001:db8:a:b::5:1</code>, and my phone is <code>2001:db8:a:b::c:d</code>.</li>
<li>I want to log into the server box.  I ssh in to the server box's address
directly.</li>
<li>The router permits SSH traffic to my server box through its firewall</li>
<li>Success!  I am logged in.</li>
</ol>

<p>
It seems pretty straight forward, But there is a catch: when your DHCPv6 lease
expires (e.g. 1 week), there is a possibility your network is assigned a new
IPv6 prefix.  Hence the IPv6 address can be thought as dynamic.
</p>

<p>
In order to get around this limitation, one can use Dynamic DNS and update a
AAAA DNS record for every host on the LAN that needs to be accessed via the
internet.  This means you'll either have to run a Dynamic DNS client on each
host, or use some sort of host discovery to set Dynamic DNS AAAA records on
another host's behalf.  Seems a bit confusing; in short when using IPv6 on a
home network, special care is needed to ensure SSH is accessible.
</p>
</div>
</div>

<div id="outline-container-org356e451" class="outline-3">
<h3 id="org356e451">Allowing ssh logins over IPv4</h3>
<div class="outline-text-3" id="text-org356e451">
<p>
Looking at IPv4, some things differ.  As in IPv6's case, one needs to allow SSH
traffic to the target box on the home network.  What differs is one does not
directly address the internal host; instead one has to address the router
(which is usually plugged directly into the modem/internet).  The router then
passes this SSH traffic to the box on the home network.  In effect the router
is <b>translating</b> between different network segments.  The feature of your
router passing traffic on a port to another host on the home network is known
as <b>port forwarding</b>.
</p>

<p>
Now that we understand the main difference, we should also discuss how IPv4
addresses are given to home ISP users.  Typically the mechanism of how your
home router gets an IPv4 address is the same as how your personal devices get
addresses from the router.  In both cases the device requesting an address uses
DHCP to solicit a IPv4 address and related configuration (such as DNS servers
and default gateway).  Again the same process is applied to each device on the
home network.  They simply get IPv4 addresses from the router, but in this
case, the router does not give out globally routable addresses, but instead
gives out private IPv4 addresses.  These private IPv4 addresses are not
globally routable, and instead depend on the router to figure out where to send
internet stuff.  Also, as with DHCPv6, there is a finite lifespan for DHCP
leases.  As such after awhile, your router's IPv4 address may change.
</p>

<p>
Let's work through a IPv4 example:
</p>

<ol class="org-ol">
<li>Your router solicits a IPv4 address from the ISP, such as <code>203.0.113.1</code>.<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>
This is the only internet-routable address used in the setup.</li>
<li>Each device on the network solicits an IPv4 address from the router.<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup>
Each device has its own private IPv4 address.<sup><a id="fnr.4" class="footref" href="#fn.4">4</a></sup>  In this example the server
box has <code>192.168.1.20</code>, the router has <code>192.168.1.1</code>, my phone has
<code>192.168.1.101</code>.</li>
<li>Internet traffic is directed towards the router (acting as the <b>default
gateway</b>), which in turn translates the network traffic.  This is done by
replacing the <b>private IPv4 address</b> and <b>source port</b> with the <b>public IPv4
address</b> and a <b>"session port"</b>, which is used to uniquely map between
traffic belonging on the internet side to traffic belonging on the home
network side.  This is <b>network address translation</b>.</li>
<li>When I want to log into the server box, I ssh into the router's public IPv4
address.</li>
<li>The router translates the ssh traffic to a the private IPv4 address space
and sends it off to the server box.  The server box then handles the ssh
session sent from the router, which then the router relays back and forth
between the server box on the private LAN with my internet computer.</li>
</ol>

<p>
Seems a bit convoluted too.  But it does work.  When combined with Dynamic DNS
to update an A DNS record for the router's public IPv4 address, it can work
pretty flawlessly.
</p>
</div>
</div>
</div>

<div id="outline-container-org1362730" class="outline-2">
<h2 id="org1362730">What can go wrong?</h2>
<div class="outline-text-2" id="text-org1362730">
<p>
When using any of the above approaches to set up SSH login, a few things can go
wrong.
</p>

<ol class="org-ol">
<li>In both IPv4 and IPv6, the router depends on the ISP to assign internet
addresses.  As such in both cases, Dynamic DNS or a similar mechanism is
needed to ensure I can log in via a DNS record, or at least know what
address works when using SSH.  If I don't know the latest internet address,
I cannot log in.</li>

<li>The router has to be specially configured to allow traffic in both IPv4 and
IPv6 situations.  Using IPv6, the router must permit traffic to the server box.
Using IPv4, the router has modify network traffic it receives on the SSH
port and pass it on to the server box.  And then it does the same to send
traffic back to my internet device.  If the router configuration breaks for
whatever reason, I cannot log in.</li>

<li>Some internet connections cannot receive SSH traffic.  Most mobile internet
service providers (such as ATE) use <b>Carrier Grade NAT</b> to allow multiple
internet subscribers to connect to the internet using the same public IPv4
address.  Port forwarding won't work with Carrier Grade NAT.  Additionally
some ISPs do nefarious things like blocking ports for you.  After all it's
pretty normal for ISPs to block SMTP (even if I think it's bonkers).</li>
</ol>

<p>
In short the network operator must cooperate with you to make this happen.  In
some cases the hardware isn't capable either.
</p>
</div>
</div>

<div id="outline-container-org69f0fbd" class="outline-2">
<h2 id="org69f0fbd">A few options</h2>
<div class="outline-text-2" id="text-org69f0fbd">
<p>
Before continuing I'd like to point out—like most technology—the exact same
tools every single user uses daily (in one form or fashion) can be used to
attack the same systems.  As such the next example is for demonstration
purposes.  Data is sent plain text and no authentication/verification of host
or user is performed.  Computers networks are only as secure as their users ;).
</p>
</div>

<div id="outline-container-org91d635e" class="outline-3">
<h3 id="org91d635e">Punt the socket using socat</h3>
<div class="outline-text-3" id="text-org91d635e">
<p>
One can use socat to (1) run a socat client that connects to a internet server,
which sends all data to the home server box's SSH port and (2) run a socat
server on the internet host which sends traffic it receives to the socat client
connected on another port on the internet server.
</p>

<p>
Let's try this out: given host <code>public.example.com</code> and your LAN host
<code>not-reachable.lan</code>, run <code>socat TCP-LISTEN:9991,fork,forever TCP-LISTEN:9992</code>
on <code>public.example.com</code>, then run <code>socat
TCP-CONNECT:public.example.com:9991,fork,forever TCP-CONNECT:localhost:22</code> on
<code>not-reachable.lan</code>.  Now run <code>ssh -p 9992 public.example.com</code>.  You should see
the familiar messages of OpenSSH.
</p>

<p>
Sounds a bit confusing, because it is.  Additionally there is not an easy
mechanism to ensure multiple ssh sessions can be used simultaneously, and to
ensure the authenticity of the socat client that connects to the internet
server.  So I wouldn't use this in production ;).  Note: socat can use OpenSSL,
which can address the authenticity problem, but I still don't think this is a
very intuitive way to solve the problem.
</p>


<figure>
<img src="../static/image/20200901_socat_diagram.png" alt="20200901_socat_diagram.png">

<figcaption><span class="figure-number">Figure 1: </span>socat topology.  Arrows point away from the connecting socket to the destination process.</figcaption>
</figure>
</div>
</div>

<div id="outline-container-org1158eb6" class="outline-3">
<h3 id="org1158eb6">Better: Using OpenSSH</h3>
<div class="outline-text-3" id="text-org1158eb6">
<p>
During a recent episode of <a href="https://linuxunplugged.com/">Linux Unplugged</a>, there was discussion of using
OpenSSH to dial in to a internet-reachable host.  The secret sauce is to use
the <code>RemoteForward</code> option (<code>ssh -R</code>).  This can be achieved like <code>ssh -R
2222:localhost:22 my-server.example</code>.  Then from the server, one can run <code>ssh
-p 2222 localhost</code> to log into the firewalled host's SSH server.  Alternately,
OpenSSH also supports forwarding a SOCKS5 proxy, which can be used in
conjunction with a web browser to browse web configuration UIs with little
effort, or with use other applications via the tool proxychains.
</p>


<figure>
<img src="../static/image/20200901_ssh_diagram.png" alt="20200901_ssh_diagram.png">

<figcaption><span class="figure-number">Figure 2: </span>ssh reverse port forwarding topology.</figcaption>
</figure>
</div>
</div>


<div id="outline-container-org47c2aa6" class="outline-3">
<h3 id="org47c2aa6">My Solution: Use OpenVPN</h3>
<div class="outline-text-3" id="text-org47c2aa6">
<p>
I wanted to allow for the firewalled host be accessible as an unique network
address, without need for SOCKS5 or other steps.  The solution I came up with
is to stand up a OpenVPN server process on the internet host, then run OpenVPN
client on the remote host.  The configuration is deceptively simple, despite
OpenVPN's featureful footprint.
</p>

<p>
Some OpenVPN operators allow users to log in via username or password
associated with their account, but this appears a bit complicated to set up.
Instead, the OpenVPN folks recommend setting up a Self-signed certificate
authority to dole out TLS certificates.  This is achieved using the very handy
script EasyRSA, which streamlines the process of creating a Certificate Authority
and issuing keypairs into a handful of very short commands.
</p>


<figure>
<img src="../static/image/20200901_openvpn_diagram.png" alt="20200901_openvpn_diagram.png">

<figcaption><span class="figure-number">Figure 3: </span>OpenVPN topology.</figcaption>
</figure>

<p>
After setting up OpenVPN like I will outline below, one can simply run <code>ssh
10.100.0.10</code>, if the home server's VPN "virtual" IP is <code>10.100.0.0</code>.  Other
services hosted on the home server are also accessible by that IP.
</p>
</div>
</div>
</div>

<div id="outline-container-orgf61e06b" class="outline-2">
<h2 id="orgf61e06b">Steps to set up (based off my playbooks)</h2>
<div class="outline-text-2" id="text-orgf61e06b">
<p>
The following steps are based off of the <a href="https://openvpn.net/community-resources/how-to/">official OpenVPN
tutorial</a> for setting up multiple clients with their own
certificates.  This means a compromise of one client's
private key will not compromise the integrity of other
client private keys.
</p>
</div>

<div id="outline-container-orgabc7cda" class="outline-3">
<h3 id="orgabc7cda">Set up the certificate authority &amp; certificates</h3>
<div class="outline-text-3" id="text-orgabc7cda">
<div class="org-src-container">
<pre class="src src-sh"><span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Download EasyRSA</span>
<span style="color: #ff69b4;">VERSION</span>=3.0.7
curl -O easy-rsa-${<span style="color: #ff69b4;">VERSION</span>}.tar.gz <span style="color: #61CE3C;">\</span>
    https://github.com/OpenVPN/easy-rsa/archive/v${<span style="color: #ff69b4;">VERSION</span>}.tar.gz
tar -xzvf easy-rsa-${<span style="color: #ff69b4;">VERSION</span>}.tar.gz
<span style="color: #4c83ff;">cd</span> easy-rsa-${<span style="color: #ff69b4;">VERSION</span>}/easyrsa3

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Get script usage (it does not understand --help)</span>
./easyrsa help

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">One-time CA and DH params initialization</span>
./easyrsa init-pki
<span style="color: #4c83ff;">echo</span> <span style="color: #61CE3C;">'My Cool CA Name'</span> | ./easyrsa build-ca nopass
./easyrsa gen-dh

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Do this for each OpenVPN Server.  Each server name</span>
<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">(e.g. "my_server") must be unique.</span>
./easyrsa build-server-full my_server nopass

<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">Do this for each OpenVPN Client.  Each client name</span>
<span style="color: #8B8989; font-style: italic;"># </span><span style="color: #8B8989; font-style: italic;">(e.g. "my_client") must be unique.</span>
./easyrsa build-client-full my_client nopass
</pre>
</div>

<p>
The generated files used later in the install are:
</p>

<dl class="org-dl">
<dt><code>pki/ca.crt</code></dt><dd>The certificate authority public
certificate.  Install alongside any other
another <code>*.crt</code> file.  (Or maybe chain
them?)</dd>
<dt><code>pki/private/ca.key</code></dt><dd>The certificate authority private
certificate.</dd>
<dt><code>pki/dh.pem</code></dt><dd>Diffie Hellman parameters, TODO what is
this for?  Install on the server.</dd>
<dt><code>pki/issued/my_server.crt</code></dt><dd>The server public
certificate.  Install on the server.</dd>
<dt><code>pki/private/my_server.key</code></dt><dd>The server private
certificate.  Install on the server.</dd>
<dt><code>pki/issued/my_client.crt</code></dt><dd>The client public
certificate.  Install on the client.</dd>
<dt><code>pki/private/my_client.key</code></dt><dd>The client private
certificate.  Install on the client.</dd>
</dl>


<p>
I currently do not have the CA management scripted by Ansible.  I am a little
uncomfortable with the idea of Ansible entirely managing the CA creation
followed by certification creation.  More experience with Ansible should help
put my concerns at ease.  Chiefly, I don't want Ansible to write out
certificates from the "master CA tree".  Sometimes a little manual operation is
pgood.
</p>
</div>
</div>

<div id="outline-container-org2b654f1" class="outline-3">
<h3 id="org2b654f1">Set up the OpenVPN Server (Internet-side)</h3>
<div class="outline-text-3" id="text-org2b654f1">
<p>
<a href="https://gitlab.com/winny/personal-cloud/-/blob/master/roles/openvpn_server/tasks/main.yml">See the corresponding Ansible role's tasks.</a>
</p>

<p>
The server's <code>openvpn.conf</code> should look like this:
</p>

<pre class="example">
tls-server

port 12345

proto udp

dev tun0

ca /etc/openvpn/secrets/ca.crt
cert /etc/openvpn/secrets/{{inventory_hostname}}.crt
key /etc/openvpn/secrets/{{inventory_hostname}}.key
dh /etc/openvpn/secrets/dh.pem

server 10.100.0.0 255.255.255.0

persist-key
persist-tun

ifconfig-pool-persist ipp.txt
push "route 10.100.0.0 255.255.255.0"

keepalive 10 120
comp-lzo

user openvpn
group openvpn

status openvpn-status.log
log /var/log/openvpn/openvpn.log
verb 4
</pre>

<p>
This is probably the easiest part.
</p>

<ol class="org-ol">
<li>Install OpenVPN. <code>apk add openvpn</code></li>
<li>Install the CA keypair.<sup><a id="fnr.5" class="footref" href="#fn.5">5</a></sup></li>
<li>Install the VPN server's keypair.</li>
<li>Install the Diffie Hellman parameters file.</li>
<li>Install the server's openvpn.conf</li>
<li>Run the server <code>openvpn --config /etc/openvpn/openvpn.conf</code></li>
</ol>
</div>
</div>

<div id="outline-container-org72b01c1" class="outline-3">
<h3 id="org72b01c1">Set up the OpenVPN Client (Your Firewalled Host)</h3>
<div class="outline-text-3" id="text-org72b01c1">
<p>
<a href="https://gitlab.com/winny/personal-cloud/-/blob/master/roles/openvpn_client/tasks/main.yml">See the corresponding Ansible role's tasks.</a>
</p>

<p>
The client's <code>openvpn.conf</code> should look like this:
</p>

<pre class="example">
client

proto udp

dev tun0

remote public.example.com 12345

nobind
resolv-retry 30

script-security 2

ca /etc/openvpn/secrets/ca.crt
cert /etc/openvpn/secrets/{{inventory_hostname}}.crt
key /etc/openvpn/secrets/{{inventory_hostname}}.key

persist-key
persist-tun

keepalive 10 120
comp-lzo

log /var/log/openvpn/openvpn.log
verb 4
</pre>

<ol class="org-ol">
<li>Install OpenVPN. <code>apk add openvpn</code></li>
<li>Install the CA public key.</li>
<li>Install the VPN Client's keypair.</li>
<li>Install the client's openvpn.conf</li>
<li>Run the client using <code>openvpn --config /etc/openvpn/openvpn.conf</code></li>
</ol>
</div>
</div>

<div id="outline-container-org6358f82" class="outline-3">
<h3 id="org6358f82">Set up another OpenVPN client on your PC</h3>
<div class="outline-text-3" id="text-org6358f82">
<p>
Follow the same instructions as setting up your firewalled host, but be sure to
generate a unique SSL keypair to identify your PC.  If the OpenVPN server, the
firewalled host OpenVPN client, and your PC's OpenVPN client are all set up
correctly, you should be able to directly connect to any of the hosts
participating in the VPN via the VPN's private IPv4 network.
</p>
</div>
</div>
</div>

<div id="outline-container-orgb426dff" class="outline-2">
<h2 id="orgb426dff">Wishlist</h2>
<div class="outline-text-2" id="text-orgb426dff">
<p>
This setup works swimmingly, but there are a few nits in the amount of effort
involved in discovering hosts connected to the VPN.  I also realized instead of
only routing directly to other VPN clients, one could also join the various
LANs, so I gave that some thought as well.
</p>
</div>

<div id="outline-container-orgb3b4552" class="outline-3">
<h3 id="orgb3b4552">VPN Host Discovery</h3>
<div class="outline-text-3" id="text-orgb3b4552">
<p>
At present I scan for remote connected hosts via:
</p>

<pre class="example">
winston@snowcrash ~ $ sudo nmap -sP -PE 10.100.0.0/24
Password: 
Starting Nmap 7.80 ( https://nmap.org ) at 2020-08-15 01:31 CDT
Nmap scan report for 10.100.0.1
Host is up (0.026s latency).
Nmap scan report for 10.100.0.6
Host is up (0.053s latency).
Nmap scan report for 10.100.0.14
Host is up (0.064s latency).
Nmap scan report for 10.100.0.10
Host is up.
Nmap done: 256 IP addresses (4 hosts up) scanned in 2.61 seconds
</pre>

<p>
In the above output, <code>10.100.0.1</code> is the OpenVPN server
address, and according to <code>ip addr show dev tun0</code>, my
current OpenVPN client is <code>10.100.0.10</code>.
</p>

<p>
Pretty icky.  Alternatively, one can take a look at the server's <code>openvpn.log</code>:
</p>

<pre class="example">
Fri Aug 14 02:02:48 2020 us=357198 cyberdemon/127.0.0.1:42995 MULTI: primary virtual IP for cyberdemon/127.0.0.1:42995: 10.100.0.18
</pre>

<p>
In both cases it's a bit tedious to figure out which IP belongs to which host
participating on the VPN.
</p>

<p>
DNS-SD (via Avahi) might be suitable for this.  Instead of scanning for
available hosts, one can simply query for a DNS-SD (DNS Service Discovery)
type, quite possibly either <code>_http._tcp</code> or <code>_ssh._tcp</code>.  <a href="https://sosheskaz.github.io/tutorial/2016/09/26/Avahi-HTTP-Service.html">Here is one such
guide</a>.
</p>
</div>
</div>

<div id="outline-container-org63d31e1" class="outline-3">
<h3 id="org63d31e1">Domain Names for VPN Hosts</h3>
<div class="outline-text-3" id="text-org63d31e1">
<p>
An related wish (which overlaps in some ways) is to configure OpenVPN to
register VPN clients' information including their assigned IP address with a
DNS server such as dnsmasq or tinydns or even busybox's dns server.  I did some
skimming about this, and came up with the conclusion that it's possible, but is
not well understood or documented, so I decided to go with host discovery via
network scanning for the time being.
</p>
</div>
</div>

<div id="outline-container-org5f7d008" class="outline-3">
<h3 id="org5f7d008">Configure the VPN Clients' LAN segments be routable from other Clients</h3>
<div class="outline-text-3" id="text-org5f7d008">
<p>
This is a killer feature I have yet to figure out.  It appears possible, but
this requires a bit of further testing, and is relatively tricky to set up
correctly, since if a VPN Client ends up using the same IP network in two
different contexts, things will silently stop working without explanation,
because that's as intended, IP is funny like that.
</p>
</div>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<code>2001:db8:a:b::/64</code> is part of <code>2001:db8::/32</code> which is reserved for
documentation in <a href="https://tools.ietf.org/html/rfc3849">RFC 3849</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
<code>203.0.113.1</code> is part of <code>203.0.113.0/24</code> (TEST-NET-3) which is reserved
for documentation in <a href="https://tools.ietf.org/html/rfc5737">RFC 5737</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
Devices could be configured on the IPv4 LAN with so-called static IPv4
addresses, but usually you don't want this.  You can achieve the same by
assigning hosts the same IPv4 every time (which are identified the network
interface's MAC address or even the optional hostname field).
</p></div></div>

<div class="footdef"><sup><a id="fn.4" class="footnum" href="#fnr.4">4</a></sup> <div class="footpara"><p class="footpara">
In this example I use <code>192.168.1.0/24</code> which is reserved for private
network use in <a href="https://tools.ietf.org/html/rfc1918">RFC 1918</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.5" class="footnum" href="#fnr.5">5</a></sup> <div class="footpara"><p class="footpara">
The CA private key is likely not necessary and probably a serious smell,
if you know anything about this, please write me explaining this.
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-vpn.html">vpn</a> <a href="tag-networking.html">networking</a> <a href="tag-linux.html">linux</a> <a href="tag-devops.html">devops</a> </div>
<div class="post-date">29 Mar 2020</div><h1 class="post-title"><a href="2020-03-29-extending-a-wireless-lan-with-a-bridged-ethernet-lan-using-mikrotik-routeros.html">Extending a wireless LAN with a bridged Ethernet LAN using Mikrotik RouterOS</a></h1>
<p>
I recently moved, and my new abode has an Ubiquiti Amplifi LAN. The
rationale is this mesh-based WiFi network eliminates the need to
install Ethernet between Wireless Access Points (APs). It works
surprisingly well. In this post I document how I extended this network
so I could place my networked devices all on the same Ethernet
segment, without needing to wire it to the Amplifi base station.
</p>

<p>
The idea is the network should look like this:
</p>


<figure>
<img src="static/image/wireless-network-topology.png" alt="wireless-network-topology.png">

</figure>

<div id="outline-container-org51023e0" class="outline-2">
<h2 id="org51023e0">Multiple Subnets Gotcha: No static routes or additional IP addresses on the Amplifi Router</h2>
<div class="outline-text-2" id="text-org51023e0">
<p>
Initially I wanted to segment my devices on its own RFC1918
network. The idea is the main Amplifi LAN would be on
<code>192.168.182.0/24</code> and my network would be on <code>10.9.8.0/24</code>. I know
I can ensure an address from each subnet is on each router, and the
routers should then be able to route between each other without any
additional configuration.
</p>

<p>
Unfortunately Amplifi does not offer a facility to add additional IP
addresses to the LAN IP configuration. Think about how absurd that
is—a router doesn't offer facility to add multiple addresses on an
interface or bridge. Yep pretty silly. This leads me to the second
approach: add static routes to make every segment on the network
routable. Unfortunately, yet again, Ubiquiti Amplifi does not offer
this standard router feature.
</p>

<p>
Given the limitations of Amplifi to not offer static routing or
multiple LAN IP addresses, I think the only approach where I could
maintain an additional subnet is with NAT (Network Address
Translation) configured, which totally defeats the purpose of having
a second subnet which could host any number of network services that
should be reachable anywhere on the network, without any port
forwarding.
</p>
</div>
</div>

<div id="outline-container-org42090c1" class="outline-2">
<h2 id="org42090c1">Configuring the Mikrotik Routerboard</h2>
<div class="outline-text-2" id="text-org42090c1">
<p>
My examples assume the user is logged into the CLI via SSH. Make
sure to read through <a href="https://wiki.mikrotik.com/wiki/Manual:TOC">the RouterOS Wiki documentation</a> and <a href="https://help.mikrotik.com/docs/display/ROS/RouterOS">upcoming
replacement wiki</a> when things are not clear.
</p>

<p>
In particular check out the guides for <a href="https://wiki.mikrotik.com/wiki/Manual:Scripting">scripting</a>, <a href="https://wiki.mikrotik.com/wiki/Manual:Console">using the console</a>,
<a href="https://wiki.mikrotik.com/wiki/Manual:First_time_startup">first-time setup</a>, and <a href="https://wiki.mikrotik.com/wiki/Manual:Troubleshooting_tools">troubleshooting tools</a>.
</p>

<p>
The steps are this:
</p>
</div>

<div id="outline-container-orge7e5644" class="outline-3">
<h3 id="orge7e5644">1) Make a backup of your current RouterOS configuration</h3>
<div class="outline-text-3" id="text-orge7e5644">
<p>
<a href="https://wiki.mikrotik.com/wiki/Manual:Configuration_Management">About the <code>/export</code> and <code>/import</code> paths</a>. Also worth reading about
<a href="https://wiki.mikrotik.com/wiki/Manual:System/Backup"><code>/system backup</code></a>.
</p>

<pre class="example">
[admin@MikroTik] &gt; # Export to local file
[admin@MikroTik] &gt; /export verbose file=2020-03-29
[admin@MikroTik] &gt; # Confirm file exists
[admin@MikroTik] &gt; /file print
 # NAME                                                 TYPE                                                       SIZE CREATION-TIME       
 0 2020-03-29.rsc                                       script                                                  40.2KiB mar/29/2020 12:44:43
 1 flash                                                disk                                                            dec/31/1969 19:00:03
 2 flash/skins                                          directory                                                       dec/31/1969 19:00:03
 3 flash/pub                                            directory                                                       mar/20/2020 03:04:00
</pre>

<p>
Then copy it over.
</p>

<pre class="example">
$ sftp admin@192.168.182.70
Connected to 192.168.182.70.
sftp&gt; ls
2020-03-29.rsc   flash
sftp&gt; get 2020-03-29.rsc
Fetching /2020-03-29.rsc to 2020-03-29.rsc
/2020-03-29.rsc                                                                                            100%   40KB   2.9MB/s   00:00    
sftp&gt; exit
</pre>
</div>
</div>

<div id="outline-container-org2a36c13" class="outline-3">
<h3 id="org2a36c13">2) Reconfigure the bridge</h3>
<div class="outline-text-3" id="text-org2a36c13">
<p>
You probably want everything on the bridge, including the <code>ether1</code>,
which is often used for WAN on a typical router setup. <a href="https://wiki.mikrotik.com/wiki/Manual:Interface/Bridge">More
information on RouterOS bridges</a>.
</p>

<pre class="example">
[admin@MikroTik] &gt; /interface bridge port print 
Flags: X - disabled, I - inactive, D - dynamic, H - hw-offload 
 #     INTERFACE                              BRIDGE                              HW  PVID PRIORITY  PATH-COST INTERNAL-PATH-COST    HORIZON
 0   H ;;; defconf
       ether2                                 bridge                              yes    1     0x80         10                 10       none
 1 I H ;;; defconf
       ether3                                 bridge                              yes    1     0x80         10                 10       none
 2 I H ;;; defconf
       ether4                                 bridge                              yes    1     0x80         10                 10       none
 3 I H ;;; defconf
       ether5                                 bridge                              yes    1     0x80         10                 10       none
 4 I   ;;; defconf
       sfp1                                   bridge                              yes    1     0x80         10                 10       none
 5 I H ether1                                 bridge                              yes    1     0x80         10                 10       none
 6 I   wlan1                                  bridge                                     1     0x80         10                 10       none
 7     wlan2                                  bridge                                     1     0x80         10                 10       none
</pre>

<p>
To add/remove devices just use <code>/interface bridge port add</code> and
<code>/interface bridge port remove</code>. Press TAB to complete stuff.
</p>
</div>
</div>

<div id="outline-container-org02eb028" class="outline-3">
<h3 id="org02eb028">3) Remove obsolete firewall rules</h3>
<div class="outline-text-3" id="text-org02eb028">
<p>
The following scripts can be copy-pasted into the terminal. More
information on RouterOS scripting <a href="https://wiki.mikrotik.com/wiki/Manual:Scripting">here</a>.
</p>

<p>
I've included the following image because I think everyone should
be able to enjoy the colorful nature of RouterOS's shell.
</p>


<figure>
<img src="static/image/firewall-remove-script.png" alt="firewall-remove-script.png">

</figure>
</div>

<div id="outline-container-orgb788b35" class="outline-4">
<h4 id="orgb788b35"><code>/ip firewall filter</code></h4>
<div class="outline-text-4" id="text-orgb788b35">
<p>
As per a suggestion on IRC (thanks drmessano) it's best to drop
all the firewall rules, since this device should be a L3 bridge,
and should not be restricting traffic.
</p>

<pre class="example">
:foreach rule in=[/ip firewall filter find] do={ \
  :if ([/ip firewall filter get $rule dynamic])  \
    do={}                                        \
    else={/ip firewall filter remove $rule}      \
};                                               \
/ip firewall filter print
</pre>
</div>
</div>

<div id="outline-container-org023f7f4" class="outline-4">
<h4 id="org023f7f4"><code>/ip firewall mangle</code></h4>
<div class="outline-text-4" id="text-org023f7f4">
<p>
I didn't see a need for any mangle rules, so this should be empty
as well.
</p>


<pre class="example">
:foreach rule in=[/ip firewall mangle find] do={ \
  :if ([/ip firewall mangle get $rule dynamic])  \
    do={}                                        \
    else={/ip firewall mangle remove $rule}      \
};                                               \
/ip firewall mangle print
</pre>
</div>
</div>

<div id="outline-container-orgf9f47bb" class="outline-4">
<h4 id="orgf9f47bb"><code>/ip firewall nat</code></h4>
<div class="outline-text-4" id="text-orgf9f47bb">
<p>
Everything here should be disabled or removed. This setup does not
use a NAT.
</p>

<pre class="example">
:foreach rule in=[/ip firewall nat find] do={ \
  :if ([/ip firewall nat get $rule dynamic])  \
    do={}                                     \
    else={/ip firewall nat remove $rule}      \
};                                            \
/ip firewall nat print
</pre>
</div>
</div>
</div>

<div id="outline-container-org22ba260" class="outline-3">
<h3 id="org22ba260">4) Disable DHCP Server</h3>
<div class="outline-text-3" id="text-org22ba260">
<p>
You can probably just run:
</p>

<pre class="example">
/ip dhcp-server disable 0
</pre>

<p>
This is necessary because this device shouldn't be doling out IP
addresses. Only one router on this subnet should be running a DHCP
server.
</p>
</div>
</div>

<div id="outline-container-orga30a431" class="outline-3">
<h3 id="orga30a431">5) Configure device IP Address</h3>
<div class="outline-text-3" id="text-orga30a431">
</div>
<div id="outline-container-org151a002" class="outline-4">
<h4 id="org151a002">Add an out-of-band management IP address</h4>
<div class="outline-text-4" id="text-org151a002">
<p>
In general it's a good idea to add out-of-band management IP
addresses to devices that don't have another way to log in. My
particular device does not have an accessible serial console, so I
need to take care to always have a way to address this
Routerboard, even if the LAN and its DHCP server goes down.
</p>

<p>
There are two ways to achieve this: use an IPv6 link-local address
or manually add a static <a href="https://tools.ietf.org/html/rfc1918">RFC1918</a> IPv4 address. I will use a static
IPv4 address.
</p>

<pre class="example">
/ip address add address=10.128.0.1/24 interface=bridge
</pre>

<p>
Make sure to write this address down, it will save a hard-reset
down the road. Maybe attach it to the unit with a printed label.
</p>

<p>
With my Linux box's Ethernet directly hooked up to the
Routerboard, I can assign another IPv4 on the same subnet, then
log into the router.
</p>

<pre class="example">
winston@snowcrash ~ $ sudo ip address add dev enp2s0 10.128.0.10/24
winston@snowcrash ~ $ ssh admin@10.128.0.1
The authenticity of host '10.128.0.1 (10.128.0.1)' can't be established.
RSA key fingerprint is SHA256:QhJryzCxFpT/wW4Mmg7R6QEnRDPeYsY2SAF/hlc7Mx4.
No matching host key fingerprint found in DNS.
Are you sure you want to continue connecting (yes/no/[fingerprint])? yes
Warning: Permanently added '10.128.0.1' (RSA) to the list of known hosts.








  MMM      MMM       KKK                          TTTTTTTTTTT      KKK
  MMMM    MMMM       KKK                          TTTTTTTTTTT      KKK
  MMM MMMM MMM  III  KKK  KKK  RRRRRR     OOOOOO      TTT     III  KKK  KKK
  MMM  MM  MMM  III  KKKKK     RRR  RRR  OOO  OOO     TTT     III  KKKKK
  MMM      MMM  III  KKK KKK   RRRRRR    OOO  OOO     TTT     III  KKK KKK
  MMM      MMM  III  KKK  KKK  RRR  RRR   OOOOOO      TTT     III  KKK  KKK

  MikroTik RouterOS 6.46.4 (c) 1999-2020       http://www.mikrotik.com/

[?]             Gives the list of available commands
command [?]     Gives help on the command and list of arguments

[Tab]           Completes the command/word. If the input is ambiguous,
                a second [Tab] gives possible options

/               Move up to base level
..              Move up one level
/command        Use command at the base level

[admin@MikroTik] &gt; 
</pre>
</div>
</div>

<div id="outline-container-org8b71cd4" class="outline-4">
<h4 id="org8b71cd4">Provision an IPv4 on the LAN for easier management</h4>
<div class="outline-text-4" id="text-org8b71cd4">
<p>
I opted to use DHCP, but I'll show both ways to assign an IP
address to the router. Before adding more DHCP clients or a static
IP, make sure to disable or remove other DHCP clients.
</p>

<pre class="example">
# Change "remove" to "disable" to keep the configuration available for later use.
foreach cl in=[/ip dhcp-client find] do={/ip dhcp-client remove $cl}; \
/ip dhcp-client print
</pre>

<p>
To add a DHCP client, run a command like this:
</p>

<pre class="example">
/ip dhcp-client add interface=bridge disabled=no
</pre>

<p>
To add a static IPv4 address, run commands like the following:
</p>

<pre class="example">
# Give the Routerboard an address
/ip address add address=192.168.182.70/24 interface=bridge

# The following two commands tell the Routerboard how to access the internet, so it
# can get updates or access cloud services.
#
# Where 192.168.182.1 is the default gateway (the main router)
/ip route add gateway=192.168.182.1
# Set the DNS servers preferring in order: the main router, Cloudflare, and Google
/ip dns set servers=192.168.182.1,1.1.1.1,8.8.8.8
</pre>
</div>
</div>
</div>


<div id="outline-container-org1893739" class="outline-3">
<h3 id="org1893739">6) Configure the WiFi</h3>
<div class="outline-text-3" id="text-org1893739">
<p>
Here is my WiFi configuration:
</p>

<pre class="example">
[admin@MikroTik] &gt; /interface wireless print 
Flags: X - disabled, R - running 
 0 X  name="wlan1" mtu=1500 l2mtu=1600 mac-address=CC:2D:E0:E1:3E:B9 arp=enabled interface-type=Atheros AR9300 mode=station-pseudobridge 
      ssid="MyCoolWifiName" frequency=auto band=2ghz-b/g/n channel-width=20/40mhz-Ce secondary-channel="" scan-list=default 
      wireless-protocol=802.11 vlan-mode=no-tag vlan-id=1 wds-mode=disabled wds-default-bridge=none wds-ignore-ssid=no bridge-mode=enabled 
      default-authentication=yes default-forwarding=yes default-ap-tx-limit=0 default-client-tx-limit=0 hide-ssid=no 
      security-profile=default compression=no 

 1  R name="wlan2" mtu=1500 l2mtu=1600 mac-address=CC:2D:E0:E1:3E:B8 arp=enabled interface-type=Atheros AR9888 mode=station-pseudobridge 
      ssid="MyCoolWifiName" frequency=auto band=5ghz-a/n/ac channel-width=20/40/80mhz-Ceee secondary-channel="" scan-list=default 
      wireless-protocol=802.11 vlan-mode=no-tag vlan-id=1 wds-mode=disabled wds-default-bridge=none wds-ignore-ssid=no bridge-mode=enabled 
      default-authentication=yes default-forwarding=yes default-ap-tx-limit=0 default-client-tx-limit=0 hide-ssid=no 
      security-profile=default compression=no 

</pre>
</div>

<div id="outline-container-orgb1cbc78" class="outline-4">
<h4 id="orgb1cbc78">1) Take the WiFi offline</h4>
<div class="outline-text-4" id="text-orgb1cbc78">
<p>
First, I recommend taking the WiFi offline until you're happy with the configuration.
</p>

<pre class="example">
/interface wireless disable numbers=0,1
</pre>
</div>
</div>

<div id="outline-container-orgb268419" class="outline-4">
<h4 id="orgb268419">2) Configure the SSID and put the Routerboard into a wireless client mode</h4>
<div class="outline-text-4" id="text-orgb268419">
<p>
Then make sure to set the <code>ssid</code> to your existing WiFi's ESSID and
<code>mode</code> to <code>station-pseudobridge</code>.
</p>

<pre class="example">
/interface wireless set numbers=0,1 mode=station-pseudobridge ssid="MyCoolWifiName"
</pre>
</div>
</div>

<div id="outline-container-orgfb95555" class="outline-4">
<h4 id="orgfb95555">3) Configure the security-profile</h4>
<div class="outline-text-4" id="text-orgfb95555">
<p>
Chances are your wireless device already has a security profile, so make
note of the <code>security-profile</code> in the <code>/interface wireless print</code>
output. It is likely <code>security-profile=default</code>.
</p>

<p>
Next configure the security-profile, mine looks like this:
</p>

<pre class="example">
[admin@MikroTik] &gt; /interface wireless security-profiles print                  
Flags: * - default 
 0 * name="default" mode=dynamic-keys authentication-types=wpa-psk,wpa2-psk unicast-ciphers=aes-ccm group-ciphers=aes-ccm 
     wpa-pre-shared-key="Top secret password here" wpa2-pre-shared-key="Top secret password here" supplicant-identity="MikroTik" eap-methods=passthrough 
     tls-mode=no-certificates tls-certificate=none mschapv2-username="" mschapv2-password="" disable-pmkid=no static-algo-0=none 
     static-key-0="" static-algo-1=none static-key-1="" static-algo-2=none static-key-2="" static-algo-3=none static-key-3="" 
     static-transmit-key=key-0 static-sta-private-algo=none static-sta-private-key="" radius-mac-authentication=no 
     radius-mac-accounting=no radius-eap-accounting=no interim-update=0s radius-mac-format=XX:XX:XX:XX:XX:XX radius-mac-mode=as-username 
     radius-called-format=mac:ssid radius-mac-caching=disabled group-key-update=5m management-protection=disabled 
     management-protection-key="" 
</pre>

<p>
In short, run the following command:
</p>

<pre class="example">
:local password "Top secret password here"; \
/interface wireless security-profiles set numbers=0 \
  wpa-pre-shared-key=$password wpa2-pre-shared-key=$password
</pre>
</div>
</div>

<div id="outline-container-org7387fb7" class="outline-4">
<h4 id="org7387fb7">4) Re-enable the WiFi and test</h4>
<div class="outline-text-4" id="text-org7387fb7">
<p>
I know the Amplifi wireless LAN supports 802.11ac and the closest
mesh-point is sufficiently close, so I'll only enable the radio
capable of 802.11ac. Looking at the output of <code>/interface wireless
    print</code> I see only <code>wlan2</code>'s <code>band</code> key contains support for
802.11ac (<code>band=5ghz-a/n/ac</code>). So I'll only enable that radio.
</p>

<pre class="example">
/interface wireless enable wlan2
</pre>

<p>
In any case once everything is set up, make sure one can ping the
internet:
</p>

<pre class="example">
admin@MikroTik] &gt; /ping google.com count=3
  SEQ HOST                                     SIZE TTL TIME  STATUS                                                                        
    0 172.217.9.46                               56  52 25ms 
    1 172.217.9.46                               56  52 24ms 
    2 172.217.9.46                               56  52 25ms 
    sent=3 received=3 packet-loss=0% min-rtt=24ms avg-rtt=24ms max-rtt=25ms 
</pre>


<p>
Some gotchas in case things don't work:
</p>
<ol class="org-ol">
<li>Can you ping the router via its shared LAN IP</li>
<li>What parts of the network can be pinged from what devices?</li>
<li>Is the WiFi SSID/Password correct?</li>
</ol>
</div>
</div>
</div>
</div>

<div id="outline-container-org8fc0692" class="outline-2">
<h2 id="org8fc0692">Conclusion</h2>
<div class="outline-text-2" id="text-org8fc0692">
<p>
Though a casual reader might consider this too many steps to
configure a network device, it is only a handful of operations. A
Router/Switch device's web configuration GUI might help streamline
this, but that doesn't mean it is any simpler to configure. Chances
are one will have to fill in more boxes and tick more fields in such
a scenario, since this is a somewhat weird and awkward network
topology.
</p>

<p>
As usual the Mikrotik Wiki helped me get this project finished in
little time. Doubly so thanks to the Mikrotik IRC channel. I rather
enjoy working with RouterOS because it feels rather state-less. When
I specify a configuration, it is usually idempotent, every line of
configuration feels relevant to the use-case, and in general feels
rather DWIM (<a href="https://en.wikipedia.org/wiki/DWIM">Do what I Mean</a>).
</p>

<p>
I hope this helps somebody, because this took some mild mental
aerobics to figure out how this works. In particular I knew that WiFi
and Ethernet have different frame formats, and Layer 2 bridging
between the two requires weird hacks that are unique to the vendor's
software/hardware. In this case using <code>station-pseudobridge</code>, the
Routerboard does Layer 2 bridging for certain traffic, and falls
back on Layer 3 for the rest. I don't fully understand it, but the
results are satisfactory.
</p>
</div>

<div id="outline-container-orgff50af4" class="outline-3">
<h3 id="orgff50af4">Edit: About the IRC channel</h3>
<div class="outline-text-3" id="text-orgff50af4">
<p>
I'm a big fan of IRC however looking over the logs for
<code>##mikrotik</code>, and my interactions, I was very lucky to never be a
target of abuse. Thankfully all I had to deal with are some low
intensity rudeness, and the repercussions of reminding the channel
maybe it's a good idea to act like adults (and that people remember
interactions like this). Indeed that is apparently a dangerous
discussion to bring up, I guess rude people don't like being told
they are being rude. I left that channel, and I think others should
avoid it.
</p>

<p>
Anyway I looked through my year's worth of logs, and found these
comments about the abuse problem in the channel. I have anonymized
the names because even trolls/rude users don't deserve personal
attacks. What isn't included are actual insults and attacks on
other users. Those are far too personal and explicit for my blog.
</p>

<pre class="example">
2019-12-19 16:39:03     PersonA       "##mikrotik You've got questions, we've got toxic mockery."
2019-12-19 16:42:14     PersonB       come for the advice, stay for the abuse

2019-12-20 09:20:23     PersonC PersonB: it worked, tyvm
2019-12-20 09:20:24     &lt;--     PersonC (~PersonC@unaffiliated/PersonC) has quit
2019-12-20 09:20:45     PersonD        wat
2019-12-20 09:21:16     PersonB       left without giving me a chance to insult him
2019-12-20 09:21:21     PersonD        damn :(
2019-12-20 09:21:55     PersonD        #mikrotik: Come for the help, stay for the abuse
2019-12-20 09:22:13     PersonB       i did that one already
2019-12-20 09:22:22     PersonB       [22:42:14] &lt;PersonB&gt; come for the advice, stay for the abuse

2019-12-28 15:21:22     PersonE       have you come for the abuse?
2019-12-28 15:30:43     PersonF        always
2019-12-28 16:03:58     PersonB       the abuse is the only way he can come

2020-01-10 16:21:21     PersonG  well you guys led the conversation in that direction
2020-01-10 16:21:27     PersonG  start calling names
2020-01-10 16:21:32     PersonG  I don't work networking
2020-01-10 16:21:41     PersonG  I am messing at home
...
2020-01-10 16:23:24     PersonG  nah, it is excuse to be rude and without any manners.
</pre>

<p>
Indeed they seem to know how inappropriately they service the
community the channel is for. As always you can write me about this
at the following email: hello AT winny DOT tech. I recommend
seeking out another communication medium for questions related to
Mikrotik.
</p>
</div>
</div>
</div>
<div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-computing.html">computing</a> <a href="tag-networking.html">networking</a> <a href="tag-mikrotik.html">mikrotik</a> </div>
<div class="post-date">18 Nov 2019</div><h1 class="post-title"><a href="2019-11-18-won-msoe-x-google-cloud-hackathon.html">Won MSOE x Google Cloud Hackathon</a></h1>
<p>
About a fortnight ago (Nov 9th) I went to the MSOE x Google Cloud
hackathon.<sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> There was pizza, soda, and Google Cloud gear. Each group
was given a <a href="https://aiyprojects.withgoogle.com/vision">Google AIY Computer Vision kit</a> to assemble, and build a
proof of concept around.
</p>

<p>
The kit contained a <a href="https://www.adafruit.com/product/3400">Raspberry Pi Zero W</a>, the <a href="https://www.adafruit.com/product/3099">Raspberry Pi Camera
Add-on</a>, a breakout board to provide simplified pin-outs for a button
with an integrated light, an additional LED that mounted next to the
camera to indicate if the camera was active, and a piezo buzzer.<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup> All
these components fit into a carefully engineered cardboard box that
folded onto itself, held together with adhesive tape. The assembled
device was remarkably robust and easy to operate.
</p>

<div id="outline-container-org0f8a453" class="outline-2">
<h2 id="org0f8a453">Challenges</h2>
<div class="outline-text-2" id="text-org0f8a453">
<p>
We were among the first group to finish building the kit. It turned
out the software on the included SD card was not exactly what we
needed, and the SD card writing software for Windows (<a href="https://etcher.io/">Etcher</a>) was a
bit unreliable and did not clearly indicate to the user of a
successful write. After a second attempt we had bootable SD card.
</p>

<p>
The system took a couple minutes to boot and resize itself. Mind
you, we did not have a Mini-HDMI to HDMI cable, nor a monitor to
output the Raspberry Pi display. Thus we had to wait, chat, and eat
pizza.
</p>

<p>
The next challenge was to &ldquo;pair&rdquo; the device with a wifi network so
one could SSH into it. There is an android app for this, and at
first we paired it with a spare android device acting as a
hotspot. Unfortunately this configuration did not give us internet
access when connected to this wireless access point. We were able to
verify the device was working, SSH in, and inspect the images we
took via the kit&rsquo;s included camera.
</p>

<p>
We moved to a more central location, as the most cognitively
demanding part was complete &#x2014; construction of the device, and
ensuring it works. This lead to more networking challenge. We wanted
a way to network this device to the internet so we could not only
log into it via SSH, but access PyPi from the device, and access
StackOverflow from our laptops on the same network. With a little
brainstroming we came up with this network topology:
</p>


<figure>
<img src="static/image/msoe-network-topology.png" alt="msoe-network-topology.png">

</figure>

<p>
Yes, as you can see the path from the internet is (A) public wifi
(B) my friend Karl&rsquo;s android phone (C) his laptop via bluetooth
tethering (D) finally a wifi network via his laptop&rsquo;s built in
wifi. We had an intemittent hiccup with nameserver configuration not
set up correctly on the host wifi network — as such any DNS would
not resolve. A quick tweak to Karl&rsquo;s network manager settings
mitigated this. And like that… we were networked together on a
private wifi network complete with internet access.
</p>

<p>
There were some other techincal issues. Because of our network
topology, the round trip time to the internet was very high,
occasionally over a second from the pi, and pip has a relatively low
timeout when installing stuff. The workaround was to <a href="https://stackoverflow.com/questions/43298872/">tell pip to
calm down, and be patient</a>. I had installed tmux so we could share a
session across the table (for pair programming), and the apt man-db
triggers <a href="https://askubuntu.com/a/1064366/436920">took around 5-15 minutes</a>; with the crunch time we had, this
felt unacceptable. The other technical issue we had was the fact the
raspbian image starts up a lot of unnecessary services by default
which eat into the rasperry pi zero w&rsquo;s very limited memory. This
caused pip to crash due to failure to allocate memory. We had to
disable lightdm (GUI) and the default vision kit demo. Had this been
a device I&rsquo;d use for more than a couple hours, I&rsquo;d go through and
disable things like GIO services, and other bloat that we never
would use.<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup>
</p>

<p>
Meanwhile our other two group members worked on a proof of concept
game. The idea the device comes up with a common word, and the user
carries the device around, showing it various text on the wall or on
paper. Using a cloud <a href="https://en.wikipedia.org/wiki/Optical_character_recognition">OCR</a> service, it can recognize the
words seen by the camera. It then will buzz happily when it is shown
the correct word, or buzz sadly if shown the wrong word. Then the
process repeats. It&rsquo;s an &ldquo;iSpy&rdquo; with computer vision and words — a
word hunt!
</p>
</div>
</div>

<div id="outline-container-orgdc5d17e" class="outline-2">
<h2 id="orgdc5d17e">Completion</h2>
<div class="outline-text-2" id="text-orgdc5d17e">
<p>
While our PoC was not deployed in time for presentations, we were
about five to ten minutes away from setting it up, and demoing
it. During the presentations, we found that many of the other groups
experienced the same issues with the Google AIY Vision Kit — due to
the Raspberry Pi platform, Raspbian, and the way one pairs it to
wifi. At least one other group managed to get some non-default code
running on their Pi. We were only given around 3-4 hours from start
to finish, with a time loss factor due to slow internet speeds to
download the initial SD card image, man-db triggers rendering the
device unusable for awhile, and dealing with the lack of suitable
networking configuration.
</p>

<p>
Given all these challenges, I think we did very well. As did every
other group that participated. We did have competition for 1st
place, because some of the other groups had PoC&rsquo;s (though some did
not get the Pi completely working) and others did get the Pi working
but did not have a PoC. We were selected as 1st place, and each was
given either a <a href="https://store.google.com/product/google_home_mini">Google Home Mini</a> or a Google Cloud hoodie. I went
with the hoodie because I don&rsquo;t want to use Google&rsquo;s <a href="https://support.google.com/googlenest/answer/7072285?hl=en">creepy</a> <a href="https://www.youtube.com/watch?v=AAP4N3KyLmM">spyware</a>
voice assistant. And the modding/reverse engineering community has
done very little with this product; nobody has loaded custom
firmware on it, for example.
</p>
</div>
</div>

<div id="outline-container-org88c7429" class="outline-2">
<h2 id="org88c7429">Conclusion</h2>
<div class="outline-text-2" id="text-org88c7429">
<p>
Our issue in seeking out a usable networking topology had be thinking:
if I simply had a device with two wifi radios, I could run one as an
Acesss Point and the other connected to Public WiFi. This device would
then yield this topology, which would be ideal for these sorts of
impromptu projects and activities:
</p>


<figure>
<img src="static/dual-wifi.png" alt="dual-wifi.png">

</figure>

<p>
In addition, it would be perfect for demonstrations of man in the
middle attacks on public wifi, or experimenting with multipath tcp and
wifi.
</p>

<p>
With these sorts of events that start early on a Saturday morning,
it&rsquo;s been useful to agree with a friend to attend the same event. That
way both parties are more likely to show up, because it wouldn&rsquo;t be
very personable to cancel last minute. We also had a wonderful team. I
later met up with most of the same team for another event (post
incoming). Hackathons are a great way to meet new people. I enjoyed
this event thoroughly.
</p>

<p>
See you at the next hackathon :)
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
There isn&rsquo;t a link online yet :(. I will update this note when
I find <b>a link</b> to the event.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
Full list of materials <a href="https://aiyprojects.withgoogle.com/vision#list-of-materials">here</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
Stay tuned as I explore why I find distros like Debian not
ideal in practice in a future post ☺
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-community.html">community</a> <a href="tag-networking.html">networking</a> </div><div id="archive">
<a href="archive.html">Other posts</a>
</div>
</div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
